/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
	"strings"
	"time"
)


// CVERecordApiService CVERecordApi service
type CVERecordApiService service

type ApiCveCnaCreateRejectRequest struct {
	ctx context.Context
	ApiService *CVERecordApiService
	id string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	createCveRecordRejectionRequest *CreateCveRecordRejectionRequest
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiCveCnaCreateRejectRequest) CVEAPIORG(cVEAPIORG string) ApiCveCnaCreateRejectRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiCveCnaCreateRejectRequest) CVEAPIUSER(cVEAPIUSER string) ApiCveCnaCreateRejectRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiCveCnaCreateRejectRequest) CVEAPIKEY(cVEAPIKEY string) ApiCveCnaCreateRejectRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

// Note: providerMetadata is set by the server. If provided, it will be overwritten.
func (r ApiCveCnaCreateRejectRequest) CreateCveRecordRejectionRequest(createCveRecordRejectionRequest CreateCveRecordRejectionRequest) ApiCveCnaCreateRejectRequest {
	r.createCveRecordRejectionRequest = &createCveRecordRejectionRequest
	return r
}

func (r ApiCveCnaCreateRejectRequest) Execute() (*CreateCveRecordRejectionResponse, *http.Response, error) {
	return r.ApiService.CveCnaCreateRejectExecute(r)
}

/*
CveCnaCreateReject Creates a rejected CVE Record for the specified ID if no record yet exists (accessible to CNAs and Secretariat)

  <h2>Access Control</h2>  <p>User must belong to an organization with the <b>CNA</b> or <b>Secretariat</b> role</p>  <h2>Expected Behavior</h2>  <p><b>CNA:</b> Creates a rejected CVE Record for a record owned by their organization</p>  <p><b>Secretariat:</b> Creates a rejected CVE Record for a record owned by any organization</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param id The CVE ID for the record being rejected
 @return ApiCveCnaCreateRejectRequest
*/
func (a *CVERecordApiService) CveCnaCreateReject(ctx context.Context, id string) ApiCveCnaCreateRejectRequest {
	return ApiCveCnaCreateRejectRequest{
		ApiService: a,
		ctx: ctx,
		id: id,
	}
}

// Execute executes the request
//  @return CreateCveRecordRejectionResponse
func (a *CVERecordApiService) CveCnaCreateRejectExecute(r ApiCveCnaCreateRejectRequest) (*CreateCveRecordRejectionResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CreateCveRecordRejectionResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CVERecordApiService.CveCnaCreateReject")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cve/{id}/reject"
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}
	if r.createCveRecordRejectionRequest == nil {
		return localVarReturnValue, nil, reportError("createCveRecordRejectionRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	// body params
	localVarPostBody = r.createCveRecordRejectionRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiCveCnaCreateSingleRequest struct {
	ctx context.Context
	ApiService *CVERecordApiService
	id string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	cveRecordMinimumRequest *CveRecordMinimumRequest
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiCveCnaCreateSingleRequest) CVEAPIORG(cVEAPIORG string) ApiCveCnaCreateSingleRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiCveCnaCreateSingleRequest) CVEAPIUSER(cVEAPIUSER string) ApiCveCnaCreateSingleRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiCveCnaCreateSingleRequest) CVEAPIKEY(cVEAPIKEY string) ApiCveCnaCreateSingleRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

// Note: providerMetadata is set by the server. If provided, it will be overwritten.
func (r ApiCveCnaCreateSingleRequest) CveRecordMinimumRequest(cveRecordMinimumRequest CveRecordMinimumRequest) ApiCveCnaCreateSingleRequest {
	r.cveRecordMinimumRequest = &cveRecordMinimumRequest
	return r
}

func (r ApiCveCnaCreateSingleRequest) Execute() (*CreateCveRecordResponse, *http.Response, error) {
	return r.ApiService.CveCnaCreateSingleExecute(r)
}

/*
CveCnaCreateSingle Creates a CVE Record from CNA Container JSON for the specified ID (accessible to CNAs and Secretariat)

  <h2>Access Control</h2>  <p>User must belong to an organization with the <b>CNA</b> or <b>Secretariat</b> role</p>  <h2>Expected Behavior</h2>  <p><b>CNA:</b> Creates CVE Record for a CVE ID owned by their organization</p>  <p><b>Secretariat:</b> Creates CVE Record for CVE IDs owned by any organization</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param id The CVE ID for the record being created
 @return ApiCveCnaCreateSingleRequest
*/
func (a *CVERecordApiService) CveCnaCreateSingle(ctx context.Context, id string) ApiCveCnaCreateSingleRequest {
	return ApiCveCnaCreateSingleRequest{
		ApiService: a,
		ctx: ctx,
		id: id,
	}
}

// Execute executes the request
//  @return CreateCveRecordResponse
func (a *CVERecordApiService) CveCnaCreateSingleExecute(r ApiCveCnaCreateSingleRequest) (*CreateCveRecordResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CreateCveRecordResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CVERecordApiService.CveCnaCreateSingle")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cve/{id}/cna"
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}
	if r.cveRecordMinimumRequest == nil {
		return localVarReturnValue, nil, reportError("cveRecordMinimumRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	// body params
	localVarPostBody = r.cveRecordMinimumRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiCveCnaUpdateRejectRequest struct {
	ctx context.Context
	ApiService *CVERecordApiService
	id string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	updateCveRecordRejectionRequest *UpdateCveRecordRejectionRequest
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiCveCnaUpdateRejectRequest) CVEAPIORG(cVEAPIORG string) ApiCveCnaUpdateRejectRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiCveCnaUpdateRejectRequest) CVEAPIUSER(cVEAPIUSER string) ApiCveCnaUpdateRejectRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiCveCnaUpdateRejectRequest) CVEAPIKEY(cVEAPIKEY string) ApiCveCnaUpdateRejectRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

// Note: providerMetadata is set by the server. If provided, it will be overwritten.
func (r ApiCveCnaUpdateRejectRequest) UpdateCveRecordRejectionRequest(updateCveRecordRejectionRequest UpdateCveRecordRejectionRequest) ApiCveCnaUpdateRejectRequest {
	r.updateCveRecordRejectionRequest = &updateCveRecordRejectionRequest
	return r
}

func (r ApiCveCnaUpdateRejectRequest) Execute() (*UpdateCveRecordRejectionResponse, *http.Response, error) {
	return r.ApiService.CveCnaUpdateRejectExecute(r)
}

/*
CveCnaUpdateReject Updates an existing CVE Record with a rejected record for the specified ID (accessible to CNAs and Secretariat)

  <h2>Access Control</h2>  <p>User must belong to an organization with the <b>CNA</b> or <b>Secretariat</b> role</p>  <h2>Expected Behavior</h2>  <p><b>CNA:</b> Updates a rejected CVE Record for a record owned by their organization</p>  <p><b>Secretariat:</b> Updates a rejected CVE Record for a record owned by any organization</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param id The CVE ID for the record being rejected
 @return ApiCveCnaUpdateRejectRequest
*/
func (a *CVERecordApiService) CveCnaUpdateReject(ctx context.Context, id string) ApiCveCnaUpdateRejectRequest {
	return ApiCveCnaUpdateRejectRequest{
		ApiService: a,
		ctx: ctx,
		id: id,
	}
}

// Execute executes the request
//  @return UpdateCveRecordRejectionResponse
func (a *CVERecordApiService) CveCnaUpdateRejectExecute(r ApiCveCnaUpdateRejectRequest) (*UpdateCveRecordRejectionResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPut
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *UpdateCveRecordRejectionResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CVERecordApiService.CveCnaUpdateReject")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cve/{id}/reject"
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}
	if r.updateCveRecordRejectionRequest == nil {
		return localVarReturnValue, nil, reportError("updateCveRecordRejectionRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	// body params
	localVarPostBody = r.updateCveRecordRejectionRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiCveCnaUpdateSingleRequest struct {
	ctx context.Context
	ApiService *CVERecordApiService
	id string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	cveRecordMinimumRequest *CveRecordMinimumRequest
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiCveCnaUpdateSingleRequest) CVEAPIORG(cVEAPIORG string) ApiCveCnaUpdateSingleRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiCveCnaUpdateSingleRequest) CVEAPIUSER(cVEAPIUSER string) ApiCveCnaUpdateSingleRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiCveCnaUpdateSingleRequest) CVEAPIKEY(cVEAPIKEY string) ApiCveCnaUpdateSingleRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

// Note: providerMetadata is set by the server. If provided, it will be overwritten.
func (r ApiCveCnaUpdateSingleRequest) CveRecordMinimumRequest(cveRecordMinimumRequest CveRecordMinimumRequest) ApiCveCnaUpdateSingleRequest {
	r.cveRecordMinimumRequest = &cveRecordMinimumRequest
	return r
}

func (r ApiCveCnaUpdateSingleRequest) Execute() (*UpdateFullCveRecordResponse, *http.Response, error) {
	return r.ApiService.CveCnaUpdateSingleExecute(r)
}

/*
CveCnaUpdateSingle Updates the CVE Record from CNA Container JSON for the specified ID (accessible to CNAs and Secretariat)

  <h2>Access Control</h2>  <p>User must belong to an organization with the <b>CNA</b> or <b>Secretariat</b> role</p>  <h2>Expected Behavior</h2>  <p><b>CNA:</b> Updates a CVE Record for records that are owned by their organization</p>  <p><b>Secretariat:</b> Updates a CVE Record for records that are owned by any organization</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param id The CVE ID for which the record is being updated
 @return ApiCveCnaUpdateSingleRequest
*/
func (a *CVERecordApiService) CveCnaUpdateSingle(ctx context.Context, id string) ApiCveCnaUpdateSingleRequest {
	return ApiCveCnaUpdateSingleRequest{
		ApiService: a,
		ctx: ctx,
		id: id,
	}
}

// Execute executes the request
//  @return UpdateFullCveRecordResponse
func (a *CVERecordApiService) CveCnaUpdateSingleExecute(r ApiCveCnaUpdateSingleRequest) (*UpdateFullCveRecordResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPut
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *UpdateFullCveRecordResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CVERecordApiService.CveCnaUpdateSingle")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cve/{id}/cna"
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}
	if r.cveRecordMinimumRequest == nil {
		return localVarReturnValue, nil, reportError("cveRecordMinimumRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	// body params
	localVarPostBody = r.cveRecordMinimumRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiCveGetFilteredRequest struct {
	ctx context.Context
	ApiService *CVERecordApiService
	timeModifiedLt *time.Time
	timeModifiedGt *time.Time
	state *string
	countOnly *bool
	assignerShortName *string
	assigner *string
	page *int32
}

// Most recent CVE record modified timestamp to retrieve &lt;br&gt;&lt;br&gt; &lt;i&gt;Timestamp format&lt;/i&gt; : yyyy-MM-ddTHH:mm:ssZZZZ
func (r ApiCveGetFilteredRequest) TimeModifiedLt(timeModifiedLt time.Time) ApiCveGetFilteredRequest {
	r.timeModifiedLt = &timeModifiedLt
	return r
}

// Earliest CVE record modified timestamp to retrieve &lt;br&gt;&lt;br&gt; &lt;i&gt;Timestamp format&lt;/i&gt; : yyyy-MM-ddTHH:mm:ssZZZZ
func (r ApiCveGetFilteredRequest) TimeModifiedGt(timeModifiedGt time.Time) ApiCveGetFilteredRequest {
	r.timeModifiedGt = &timeModifiedGt
	return r
}

// Filter by state
func (r ApiCveGetFilteredRequest) State(state string) ApiCveGetFilteredRequest {
	r.state = &state
	return r
}

// Get count of records that match query. Accepted values are 1, true, or yes to indicate true, and 0, false, or no to indicate false
func (r ApiCveGetFilteredRequest) CountOnly(countOnly bool) ApiCveGetFilteredRequest {
	r.countOnly = &countOnly
	return r
}

// Filter by assignerShortName
func (r ApiCveGetFilteredRequest) AssignerShortName(assignerShortName string) ApiCveGetFilteredRequest {
	r.assignerShortName = &assignerShortName
	return r
}

// Filter by assigner org UUID
func (r ApiCveGetFilteredRequest) Assigner(assigner string) ApiCveGetFilteredRequest {
	r.assigner = &assigner
	return r
}

// The current page in the paginator
func (r ApiCveGetFilteredRequest) Page(page int32) ApiCveGetFilteredRequest {
	r.page = &page
	return r
}

func (r ApiCveGetFilteredRequest) Execute() (*CveGetFiltered200Response, *http.Response, error) {
	return r.ApiService.CveGetFilteredExecute(r)
}

/*
CveGetFiltered Retrieves all CVE Records after applying the query parameters as filters (accessible to Secretariat)

  <h2>Access Control</h2>  <p>User must belong to an organization with the <b>Secretariat</b> role</p>  <h2>Expected Behavior</h2>  <p><b>Secretariat:</b> Retrieves all CVE records for all organizations</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @return ApiCveGetFilteredRequest
*/
func (a *CVERecordApiService) CveGetFiltered(ctx context.Context) ApiCveGetFilteredRequest {
	return ApiCveGetFilteredRequest{
		ApiService: a,
		ctx: ctx,
	}
}

// Execute executes the request
//  @return CveGetFiltered200Response
func (a *CVERecordApiService) CveGetFilteredExecute(r ApiCveGetFilteredRequest) (*CveGetFiltered200Response, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CveGetFiltered200Response
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CVERecordApiService.CveGetFiltered")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cve"

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if r.timeModifiedLt != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "time_modified.lt", r.timeModifiedLt, "")
	}
	if r.timeModifiedGt != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "time_modified.gt", r.timeModifiedGt, "")
	}
	if r.state != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "state", r.state, "")
	}
	if r.countOnly != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "count_only", r.countOnly, "")
	}
	if r.assignerShortName != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "assigner_short_name", r.assignerShortName, "")
	}
	if r.assigner != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "assigner", r.assigner, "")
	}
	if r.page != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "page", r.page, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiCveGetSingleRequest struct {
	ctx context.Context
	ApiService *CVERecordApiService
	id string
}

func (r ApiCveGetSingleRequest) Execute() (*CveGetSingle200Response, *http.Response, error) {
	return r.ApiService.CveGetSingleExecute(r)
}

/*
CveGetSingle Returns a CVE Record by CVE ID (accessible to all users)

  <h2>Access Control</h2>  <p>Endpoint is accessible to all</p>  <h2>Expected Behavior</h2>  <p><b>All users:</b> Retrieves the CVE Record specified</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param id The CVE ID for the Record to be retrieved
 @return ApiCveGetSingleRequest
*/
func (a *CVERecordApiService) CveGetSingle(ctx context.Context, id string) ApiCveGetSingleRequest {
	return ApiCveGetSingleRequest{
		ApiService: a,
		ctx: ctx,
		id: id,
	}
}

// Execute executes the request
//  @return CveGetSingle200Response
func (a *CVERecordApiService) CveGetSingleExecute(r ApiCveGetSingleRequest) (*CveGetSingle200Response, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CveGetSingle200Response
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CVERecordApiService.CveGetSingle")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cve/{id}"
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 429 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiCveSubmitRequest struct {
	ctx context.Context
	ApiService *CVERecordApiService
	id string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	createFullCveRecordRequest *CreateFullCveRecordRequest
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiCveSubmitRequest) CVEAPIORG(cVEAPIORG string) ApiCveSubmitRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiCveSubmitRequest) CVEAPIUSER(cVEAPIUSER string) ApiCveSubmitRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiCveSubmitRequest) CVEAPIKEY(cVEAPIKEY string) ApiCveSubmitRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

func (r ApiCveSubmitRequest) CreateFullCveRecordRequest(createFullCveRecordRequest CreateFullCveRecordRequest) ApiCveSubmitRequest {
	r.createFullCveRecordRequest = &createFullCveRecordRequest
	return r
}

func (r ApiCveSubmitRequest) Execute() (*CreateCveRecordResponse, *http.Response, error) {
	return r.ApiService.CveSubmitExecute(r)
}

/*
CveSubmit Creates a CVE Record from full CVE Record JSON for the specified ID (accessible to Secretariat.)

  <h2>Access Control</h2>  <p>User must belong to an organization with the <b>Secretariat</b> role</p>  <h2>Expected Behavior</h2>  <p><b>Secretariat:</b> Creates a CVE Record for any organization</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param id The CVE ID for the record being submitted
 @return ApiCveSubmitRequest
*/
func (a *CVERecordApiService) CveSubmit(ctx context.Context, id string) ApiCveSubmitRequest {
	return ApiCveSubmitRequest{
		ApiService: a,
		ctx: ctx,
		id: id,
	}
}

// Execute executes the request
//  @return CreateCveRecordResponse
func (a *CVERecordApiService) CveSubmitExecute(r ApiCveSubmitRequest) (*CreateCveRecordResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CreateCveRecordResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CVERecordApiService.CveSubmit")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cve/{id}"
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}
	if r.createFullCveRecordRequest == nil {
		return localVarReturnValue, nil, reportError("createFullCveRecordRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	// body params
	localVarPostBody = r.createFullCveRecordRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiCveUpdateSingleRequest struct {
	ctx context.Context
	ApiService *CVERecordApiService
	id string
	cVEAPIORG *string
	cVEAPIUSER *string
	cVEAPIKEY *string
	createFullCveRecordRequest *CreateFullCveRecordRequest
}

// The shortname for the organization associated with the user requesting authentication
func (r ApiCveUpdateSingleRequest) CVEAPIORG(cVEAPIORG string) ApiCveUpdateSingleRequest {
	r.cVEAPIORG = &cVEAPIORG
	return r
}

// The username for the account making the request
func (r ApiCveUpdateSingleRequest) CVEAPIUSER(cVEAPIUSER string) ApiCveUpdateSingleRequest {
	r.cVEAPIUSER = &cVEAPIUSER
	return r
}

// The user&#39;s API key
func (r ApiCveUpdateSingleRequest) CVEAPIKEY(cVEAPIKEY string) ApiCveUpdateSingleRequest {
	r.cVEAPIKEY = &cVEAPIKEY
	return r
}

func (r ApiCveUpdateSingleRequest) CreateFullCveRecordRequest(createFullCveRecordRequest CreateFullCveRecordRequest) ApiCveUpdateSingleRequest {
	r.createFullCveRecordRequest = &createFullCveRecordRequest
	return r
}

func (r ApiCveUpdateSingleRequest) Execute() (*UpdateFullCveRecordResponse, *http.Response, error) {
	return r.ApiService.CveUpdateSingleExecute(r)
}

/*
CveUpdateSingle Updates a CVE Record from full CVE Record JSON for the specified ID (accessible to Secretariat.)

  <h2>Access Control</h2>  <p>User must belong to an organization with the <b>Secretariat</b> role</p>  <h2>Expected Behavior</h2>  <p><b>Secretariat:</b> Updates a CVE Record for any organization</p>

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param id The CVE ID for the record being updated
 @return ApiCveUpdateSingleRequest
*/
func (a *CVERecordApiService) CveUpdateSingle(ctx context.Context, id string) ApiCveUpdateSingleRequest {
	return ApiCveUpdateSingleRequest{
		ApiService: a,
		ctx: ctx,
		id: id,
	}
}

// Execute executes the request
//  @return UpdateFullCveRecordResponse
func (a *CVERecordApiService) CveUpdateSingleExecute(r ApiCveUpdateSingleRequest) (*UpdateFullCveRecordResponse, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPut
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *UpdateFullCveRecordResponse
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CVERecordApiService.CveUpdateSingle")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cve/{id}"
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}
	if r.cVEAPIORG == nil {
		return localVarReturnValue, nil, reportError("cVEAPIORG is required and must be specified")
	}
	if r.cVEAPIUSER == nil {
		return localVarReturnValue, nil, reportError("cVEAPIUSER is required and must be specified")
	}
	if r.cVEAPIKEY == nil {
		return localVarReturnValue, nil, reportError("cVEAPIKEY is required and must be specified")
	}
	if r.createFullCveRecordRequest == nil {
		return localVarReturnValue, nil, reportError("createFullCveRecordRequest is required and must be specified")
	}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-ORG", r.cVEAPIORG, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-USER", r.cVEAPIUSER, "")
	parameterAddToHeaderOrQuery(localVarHeaderParams, "CVE-API-KEY", r.cVEAPIKEY, "")
	// body params
	localVarPostBody = r.createFullCveRecordRequest
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		if localVarHTTPResponse.StatusCode == 400 {
			var v BadRequest
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 401 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 403 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 404 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
			return localVarReturnValue, localVarHTTPResponse, newErr
		}
		if localVarHTTPResponse.StatusCode == 500 {
			var v Generic
			err = a.client.decode(&v, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
			if err != nil {
				newErr.error = err.Error()
				return localVarReturnValue, localVarHTTPResponse, newErr
			}
					newErr.error = formatErrorMessage(localVarHTTPResponse.Status, &v)
					newErr.model = v
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
